package com.hive.udf;

import com.fasterxml.jackson.databind.ObjectMapper;
import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.apache.hadoop.hive.ql.exec.UDFArgumentException;
import org.apache.hadoop.hive.ql.exec.UDFArgumentLengthException;
import org.apache.hadoop.hive.ql.exec.UDFArgumentTypeException;
import org.apache.hadoop.hive.ql.metadata.HiveException;
import org.apache.hadoop.hive.ql.udf.generic.GenericUDF;
import org.apache.hadoop.hive.serde2.objectinspector.ObjectInspector;
import org.apache.hadoop.hive.serde2.objectinspector.primitive.PrimitiveObjectInspectorFactory;
import org.apache.hadoop.io.Text;

/* loaded from: IpToLocUdf.class */
public class IpToLocUdf extends GenericUDF {
    public static List<Map<String, String>> mapList;

    static {
        mapList = new ArrayList();
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            mapList = (List) objectMapper.readValue(new File("/root/eduhq/data/area.json"), List.class);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public ObjectInspector initialize(ObjectInspector[] objectInspectors) throws UDFArgumentException {
        if (objectInspectors.length != 1) {
            throw new UDFArgumentLengthException("传入的参数长度不正确!");
        }
        if (!objectInspectors[0].getCategory().equals(ObjectInspector.Category.PRIMITIVE)) {
            throw new UDFArgumentTypeException(0, "传入的参数类型不正确!!!");
        }
        return PrimitiveObjectInspectorFactory.javaStringObjectInspector;
    }

    public Object evaluate(GenericUDF.DeferredObject[] deferredObjects) throws HiveException {
        if (deferredObjects[0].get() == null) {
            return "";
        }
        int index = (int) (Math.random() * mapList.size());
        String pro_city = String.valueOf(mapList.get(index).get("province")) + "_" + mapList.get(index).get("city");
        Text new_str = new Text(pro_city.getBytes(StandardCharsets.UTF_8));
        return new_str;
    }

    public String getDisplayString(String[] strings) {
        return "";
    }

    public static void main(String[] args) {
        int index = (int) (Math.random() * mapList.size());
        String pro_city = String.valueOf(mapList.get(index).get("province")) + "_" + mapList.get(index).get("city");
        System.out.println(pro_city);
    }
}
